// Playlist Manager v1.0
// Written by David J. Stein, Esq. See "License.html" for information on terms and conditions of use.
//
// This module contains the code for a very simple window that asks for the name of a new playlist.

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace PlaylistManagerNS {

	public class NewPlaylistDialog : System.Windows.Forms.Form	{

		#region Variables and initialization code

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.Button btnCancel;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox txtPlaylistName;
		public string strNewPlaylistName = "";

		public NewPlaylistDialog()	{
			InitializeComponent();
		}

		#region Uninteresting Windows Form Designer generated code
		protected override void Dispose(bool disposing)		{
			if (disposing) {
				if (components != null) {
				components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

	private void InitializeComponent()	{
		System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(NewPlaylistDialog));
		this.label1 = new System.Windows.Forms.Label();
		this.txtPlaylistName = new System.Windows.Forms.TextBox();
		this.btnOK = new System.Windows.Forms.Button();
		this.btnCancel = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(8, 8);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(80, 23);
		this.label1.TabIndex = 0;
		this.label1.Text = "Playlist Name:";
		this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
		// 
		// txtPlaylistName
		// 
		this.txtPlaylistName.Location = new System.Drawing.Point(88, 8);
		this.txtPlaylistName.Name = "txtPlaylistName";
		this.txtPlaylistName.Size = new System.Drawing.Size(192, 20);
		this.txtPlaylistName.TabIndex = 1;
		this.txtPlaylistName.Text = "";
		this.txtPlaylistName.TextChanged += new System.EventHandler(this.txtPlaylistName_TextChanged);
		// 
		// btnOK
		// 
		this.btnOK.Enabled = false;
		this.btnOK.Location = new System.Drawing.Point(53, 40);
		this.btnOK.Name = "btnOK";
		this.btnOK.TabIndex = 2;
		this.btnOK.Text = "Create";
		this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
		// 
		// btnCancel
		// 
		this.btnCancel.Location = new System.Drawing.Point(165, 40);
		this.btnCancel.Name = "btnCancel";
		this.btnCancel.TabIndex = 3;
		this.btnCancel.Text = "Cancel";
		this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
		// 
		// NewPlaylistDialog
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 73);
		this.Controls.Add(this.btnCancel);
		this.Controls.Add(this.btnOK);
		this.Controls.Add(this.txtPlaylistName);
		this.Controls.Add(this.label1);
		this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
		this.Name = "NewPlaylistDialog";
		this.Text = "Create Playlist";
		this.ResumeLayout(false);

	}
		#endregion

		#endregion

		#region User control event handlers

		private void btnOK_Click(object sender, System.EventArgs e) {
			Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e) {
			strNewPlaylistName = "";
			Close();
		}

		private void txtPlaylistName_TextChanged(object sender, System.EventArgs e) {
			strNewPlaylistName = txtPlaylistName.Text;
			btnOK.Enabled = (strNewPlaylistName.Length > 0 ? true : false);
		}

		#endregion

	}
}
