// Playlist Manager v1.0
// Written by David J. Stein, Esq. See "License.html" for information on terms and conditions of use.
//
// This module contains the code for the main Playlist Manager application.

#region Using declarations

using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

#endregion

namespace PlaylistManagerNS {

	public class PlaylistManager : System.Windows.Forms.Form {

		#region Variables, initialization code, and Main

		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListBox lstTracks;
		private System.Windows.Forms.ListBox lstPlaylists;
		private System.Windows.Forms.Button btnAddPlaylist;
		private System.Windows.Forms.Button btnDeletePlaylist;
		private System.Windows.Forms.Button btnSave;
		private System.Windows.Forms.Button btnChooseFolder;
		private System.Windows.Forms.ListBox lstPlaylistContents;
		private System.Windows.Forms.TextBox txtTrackSearch;
		private System.Windows.Forms.Button btnAddTracksToPlaylists;
		private System.Windows.Forms.TextBox txtViewingPlaylist;
		private System.Windows.Forms.Button btnPlaylistContentsClear;
		private System.Windows.Forms.Button btnPlaylistContentsDeleteTracks;
		private System.Windows.Forms.Button btnPlaylistContentsMoveUp;
		private System.Windows.Forms.Button btnPlaylistContentsMoveDown;
		private System.Windows.Forms.Label lblSearch;
		private System.Windows.Forms.Label lblPlaylist;
		private Hashtable hTracks;
		private Hashtable hPlaylists;
		bool bUpdatingTracks = false;
		bool bUpdatingPlaylists = false;
		bool bControlDown = false;
		private string strPath = "";

		public PlaylistManager() {
			InitializeComponent();
		}

		#region Uninteresting Windows Form Designer generated code
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlaylistManager));
			this.lstTracks = new System.Windows.Forms.ListBox();
			this.lstPlaylists = new System.Windows.Forms.ListBox();
			this.btnAddPlaylist = new System.Windows.Forms.Button();
			this.btnDeletePlaylist = new System.Windows.Forms.Button();
			this.btnSave = new System.Windows.Forms.Button();
			this.btnChooseFolder = new System.Windows.Forms.Button();
			this.lstPlaylistContents = new System.Windows.Forms.ListBox();
			this.lblSearch = new System.Windows.Forms.Label();
			this.txtTrackSearch = new System.Windows.Forms.TextBox();
			this.btnPlaylistContentsClear = new System.Windows.Forms.Button();
			this.btnPlaylistContentsDeleteTracks = new System.Windows.Forms.Button();
			this.btnPlaylistContentsMoveUp = new System.Windows.Forms.Button();
			this.btnPlaylistContentsMoveDown = new System.Windows.Forms.Button();
			this.btnAddTracksToPlaylists = new System.Windows.Forms.Button();
			this.txtViewingPlaylist = new System.Windows.Forms.TextBox();
			this.lblPlaylist = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lstTracks
			// 
			this.lstTracks.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.lstTracks.Location = new System.Drawing.Point(8, 32);
			this.lstTracks.Name = "lstTracks";
			this.lstTracks.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.lstTracks.Size = new System.Drawing.Size(224, 238);
			this.lstTracks.Sorted = true;
			this.lstTracks.TabIndex = 0;
			this.lstTracks.SelectedIndexChanged += new System.EventHandler(this.lstTracks_SelectedIndexChanged);
			// 
			// lstPlaylists
			// 
			this.lstPlaylists.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.lstPlaylists.Location = new System.Drawing.Point(240, 32);
			this.lstPlaylists.Name = "lstPlaylists";
			this.lstPlaylists.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.lstPlaylists.Size = new System.Drawing.Size(184, 238);
			this.lstPlaylists.Sorted = true;
			this.lstPlaylists.TabIndex = 1;
			this.lstPlaylists.SelectedIndexChanged += new System.EventHandler(this.lstPlaylists_SelectedIndexChanged);
			// 
			// btnAddPlaylist
			// 
			this.btnAddPlaylist.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnAddPlaylist.Location = new System.Drawing.Point(240, 280);
			this.btnAddPlaylist.Name = "btnAddPlaylist";
			this.btnAddPlaylist.Size = new System.Drawing.Size(96, 23);
			this.btnAddPlaylist.TabIndex = 3;
			this.btnAddPlaylist.Text = "Create";
			this.btnAddPlaylist.Click += new System.EventHandler(this.btnAddPlaylist_Click);
			// 
			// btnDeletePlaylist
			// 
			this.btnDeletePlaylist.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnDeletePlaylist.Location = new System.Drawing.Point(336, 280);
			this.btnDeletePlaylist.Name = "btnDeletePlaylist";
			this.btnDeletePlaylist.Size = new System.Drawing.Size(88, 23);
			this.btnDeletePlaylist.TabIndex = 4;
			this.btnDeletePlaylist.Text = "Delete";
			this.btnDeletePlaylist.Click += new System.EventHandler(this.btnDeletePlaylist_Click);
			// 
			// btnSave
			// 
			this.btnSave.Location = new System.Drawing.Point(280, 8);
			this.btnSave.Name = "btnSave";
			this.btnSave.Size = new System.Drawing.Size(104, 23);
			this.btnSave.TabIndex = 5;
			this.btnSave.Text = "Write Playlists";
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			// 
			// btnChooseFolder
			// 
			this.btnChooseFolder.Location = new System.Drawing.Point(72, 8);
			this.btnChooseFolder.Name = "btnChooseFolder";
			this.btnChooseFolder.Size = new System.Drawing.Size(104, 23);
			this.btnChooseFolder.TabIndex = 6;
			this.btnChooseFolder.Text = "Choose Folder";
			this.btnChooseFolder.Click += new System.EventHandler(this.btnChooseFolder_Click);
			// 
			// lstPlaylistContents
			// 
			this.lstPlaylistContents.Anchor = System.Windows.Forms.AnchorStyles.None;
			this.lstPlaylistContents.Location = new System.Drawing.Point(432, 32);
			this.lstPlaylistContents.Name = "lstPlaylistContents";
			this.lstPlaylistContents.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.lstPlaylistContents.Size = new System.Drawing.Size(224, 238);
			this.lstPlaylistContents.TabIndex = 17;
			// 
			// lblSearch
			// 
			this.lblSearch.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.lblSearch.Location = new System.Drawing.Point(8, 280);
			this.lblSearch.Name = "lblSearch";
			this.lblSearch.Size = new System.Drawing.Size(48, 16);
			this.lblSearch.TabIndex = 18;
			this.lblSearch.Text = "Search:";
			this.lblSearch.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// txtTrackSearch
			// 
			this.txtTrackSearch.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.txtTrackSearch.Location = new System.Drawing.Point(56, 280);
			this.txtTrackSearch.Name = "txtTrackSearch";
			this.txtTrackSearch.Size = new System.Drawing.Size(112, 20);
			this.txtTrackSearch.TabIndex = 19;
			this.txtTrackSearch.Text = "";
			this.txtTrackSearch.TextChanged += new System.EventHandler(this.txtTrackSearch_TextChanged);
			// 
			// btnPlaylistContentsClear
			// 
			this.btnPlaylistContentsClear.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnPlaylistContentsClear.Location = new System.Drawing.Point(616, 280);
			this.btnPlaylistContentsClear.Name = "btnPlaylistContentsClear";
			this.btnPlaylistContentsClear.Size = new System.Drawing.Size(40, 23);
			this.btnPlaylistContentsClear.TabIndex = 20;
			this.btnPlaylistContentsClear.Text = "Clear";
			this.btnPlaylistContentsClear.Click += new System.EventHandler(this.btnPlaylistContentsClear_Click);
			// 
			// btnPlaylistContentsDeleteTracks
			// 
			this.btnPlaylistContentsDeleteTracks.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnPlaylistContentsDeleteTracks.Location = new System.Drawing.Point(568, 280);
			this.btnPlaylistContentsDeleteTracks.Name = "btnPlaylistContentsDeleteTracks";
			this.btnPlaylistContentsDeleteTracks.Size = new System.Drawing.Size(48, 23);
			this.btnPlaylistContentsDeleteTracks.TabIndex = 21;
			this.btnPlaylistContentsDeleteTracks.Text = "Delete";
			this.btnPlaylistContentsDeleteTracks.Click += new System.EventHandler(this.btnPlaylistContentsDeleteTracks_Click);
			// 
			// btnPlaylistContentsMoveUp
			// 
			this.btnPlaylistContentsMoveUp.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnPlaylistContentsMoveUp.Location = new System.Drawing.Point(432, 280);
			this.btnPlaylistContentsMoveUp.Name = "btnPlaylistContentsMoveUp";
			this.btnPlaylistContentsMoveUp.Size = new System.Drawing.Size(64, 23);
			this.btnPlaylistContentsMoveUp.TabIndex = 22;
			this.btnPlaylistContentsMoveUp.Text = "Move Up";
			this.btnPlaylistContentsMoveUp.Click += new System.EventHandler(this.btnPlaylistContentsMoveUp_Click);
			// 
			// btnPlaylistContentsMoveDown
			// 
			this.btnPlaylistContentsMoveDown.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnPlaylistContentsMoveDown.Location = new System.Drawing.Point(496, 280);
			this.btnPlaylistContentsMoveDown.Name = "btnPlaylistContentsMoveDown";
			this.btnPlaylistContentsMoveDown.Size = new System.Drawing.Size(72, 23);
			this.btnPlaylistContentsMoveDown.TabIndex = 23;
			this.btnPlaylistContentsMoveDown.Text = "Move Down";
			this.btnPlaylistContentsMoveDown.Click += new System.EventHandler(this.btnPlaylistContentsMoveDown_Click);
			// 
			// btnAddTracksToPlaylists
			// 
			this.btnAddTracksToPlaylists.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnAddTracksToPlaylists.Location = new System.Drawing.Point(176, 280);
			this.btnAddTracksToPlaylists.Name = "btnAddTracksToPlaylists";
			this.btnAddTracksToPlaylists.Size = new System.Drawing.Size(56, 23);
			this.btnAddTracksToPlaylists.TabIndex = 24;
			this.btnAddTracksToPlaylists.Text = "Add";
			this.btnAddTracksToPlaylists.Click += new System.EventHandler(this.btnAddTracksToPlaylists_Click);
			// 
			// txtViewingPlaylist
			// 
			this.txtViewingPlaylist.Location = new System.Drawing.Point(480, 8);
			this.txtViewingPlaylist.Name = "txtViewingPlaylist";
			this.txtViewingPlaylist.ReadOnly = true;
			this.txtViewingPlaylist.Size = new System.Drawing.Size(176, 20);
			this.txtViewingPlaylist.TabIndex = 26;
			this.txtViewingPlaylist.Text = "";
			// 
			// lblPlaylist
			// 
			this.lblPlaylist.Location = new System.Drawing.Point(432, 8);
			this.lblPlaylist.Name = "lblPlaylist";
			this.lblPlaylist.Size = new System.Drawing.Size(48, 23);
			this.lblPlaylist.TabIndex = 27;
			this.lblPlaylist.Text = "Playlist:";
			this.lblPlaylist.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// PlaylistManager
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 305);
			this.Controls.Add(this.lblPlaylist);
			this.Controls.Add(this.txtViewingPlaylist);
			this.Controls.Add(this.btnAddTracksToPlaylists);
			this.Controls.Add(this.btnPlaylistContentsMoveDown);
			this.Controls.Add(this.btnPlaylistContentsMoveUp);
			this.Controls.Add(this.btnPlaylistContentsDeleteTracks);
			this.Controls.Add(this.btnPlaylistContentsClear);
			this.Controls.Add(this.txtTrackSearch);
			this.Controls.Add(this.lblSearch);
			this.Controls.Add(this.lstPlaylistContents);
			this.Controls.Add(this.btnChooseFolder);
			this.Controls.Add(this.btnSave);
			this.Controls.Add(this.btnDeletePlaylist);
			this.Controls.Add(this.btnAddPlaylist);
			this.Controls.Add(this.lstPlaylists);
			this.Controls.Add(this.lstTracks);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.KeyPreview = true;
			this.MinimumSize = new System.Drawing.Size(672, 336);
			this.Name = "PlaylistManager";
			this.Text = "Playlist Manager";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.PlaylistManager_KeyDown);
			this.Resize += new System.EventHandler(this.PlaylistManager_Resize);
			this.Load += new System.EventHandler(this.PlaylistManager_Load);
			this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.PlaylistManager_KeyUp);
			this.ResumeLayout(false);

		}
		protected override void Dispose(bool disposing) {
			if (disposing) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new PlaylistManager());
		}

		#endregion

		#region User control event handlers

		private void btnChooseFolder_Click(object sender, System.EventArgs e) {
			System.Windows.Forms.FolderBrowserDialog f = new FolderBrowserDialog();
			if (f.ShowDialog() == DialogResult.OK)
				ScanFolder(f.SelectedPath);
		}

		private void btnMapPlaylists_Click(object sender, System.EventArgs e) {
			if (bUpdatingPlaylists == false) {
				if (lstPlaylists.SelectedItems.Count == 0)
					lstTracks.ClearSelected();
				else {
					bUpdatingTracks = true;
					lstTracks.BeginUpdate();
					lstTracks.ClearSelected();
					foreach (string strSelectedPlaylist in lstPlaylists.SelectedItems) {
						ArrayList aPlaylist = ((ArrayList) hPlaylists[strSelectedPlaylist]);
						foreach (string strPlaylistTrack in aPlaylist) {
							int iTrackIndex = lstTracks.Items.IndexOf(strPlaylistTrack);
							if (iTrackIndex > -1)
								lstTracks.SetSelected(iTrackIndex, true);
						}
					}
					bUpdatingTracks = false;
					lstTracks.EndUpdate();
				}
			}
		}

		private void btnFilterTracks_Click(object sender, System.EventArgs e) {
			lstTracks.BeginUpdate();
			for (int i = 0; i < lstTracks.Items.Count;) {
				if (lstTracks.SelectedItems.Contains(lstTracks.Items[i]))
					i++;
				else
					lstTracks.Items.RemoveAt(i);
			}
			lstTracks.EndUpdate();
		}

		private void btnUnfilterTracks_Click(object sender, System.EventArgs e) {
			lstTracks.BeginUpdate();
			foreach (string strTrack in hTracks.Keys) {
				if (lstTracks.Items.Contains(strTrack) == false)
					lstTracks.Items.Add(strTrack);
			}
			lstTracks.EndUpdate();
		}

		private void btnFilterPlaylists_Click(object sender, System.EventArgs e) {
			lstPlaylists.BeginUpdate();
			for (int i = 0; i < lstPlaylists.Items.Count;) {
				if (lstPlaylists.SelectedItems.Contains(lstPlaylists.Items[i]))
					i++;
				else
					lstPlaylists.Items.RemoveAt(i);
			}
			lstPlaylists.EndUpdate();
		}

		private void btnUnfilterPlaylists_Click(object sender, System.EventArgs e) {
			lstPlaylists.BeginUpdate();
			foreach (string strPlaylist in hPlaylists.Keys) {
				if (lstPlaylists.Items.Contains(strPlaylist) == false)
					lstPlaylists.Items.Add(strPlaylist);
			}
			lstPlaylists.EndUpdate();
		}

		private void btnClearPlaylists_Click(object sender, System.EventArgs e) {
			lstPlaylists.ClearSelected();
		}

		private void btnClearTracks_Click(object sender, System.EventArgs e) {
			lstTracks.ClearSelected();
		}

		private void btnAddTracksToPlaylists_Click(object sender, System.EventArgs e) {
			foreach (string strTrack in lstTracks.SelectedItems) {
				foreach (string strPlaylist in lstPlaylists.SelectedItems) {
					ArrayList aPlaylist = (ArrayList) hPlaylists[strPlaylist];
					if (aPlaylist.Contains(strTrack) == false)
						aPlaylist.Add(strTrack);
				}
			}
			UpdatePlaylistContents();
		}

		private void btnPlaylistContentsMoveUp_Click(object sender, System.EventArgs e) {
			if (txtViewingPlaylist.Text.Length > 0) {
				ArrayList aPlaylist = (ArrayList) hPlaylists[txtViewingPlaylist.Text];
				if (aPlaylist != null) {
					ArrayList aSelectedTracks = new ArrayList();
					foreach (string strTrack in lstPlaylistContents.SelectedItems) {
						aSelectedTracks.Add(strTrack);
						int iIndex = aPlaylist.IndexOf(strTrack);
						if (iIndex > 0) {
							aPlaylist.RemoveAt(iIndex);
							aPlaylist.Insert(iIndex - 1, strTrack);
						}
					}
					UpdatePlaylistContents();
					foreach (string strTrack in aSelectedTracks)
						lstPlaylistContents.SetSelected(lstPlaylistContents.Items.IndexOf(strTrack), true);
				}
			}
		}

		private void btnPlaylistContentsMoveDown_Click(object sender, System.EventArgs e) {
			if (txtViewingPlaylist.Text.Length > 0) {
				ArrayList aPlaylist = (ArrayList) hPlaylists[txtViewingPlaylist.Text];
				if (aPlaylist != null) {
					ArrayList aSelectedTracks = new ArrayList();
					for (int i = lstPlaylistContents.SelectedItems.Count - 1; i >= 0; i--) {
						string strTrack = (string) lstPlaylistContents.SelectedItems[i];
						aSelectedTracks.Add(strTrack);
						int iIndex = aPlaylist.IndexOf(strTrack);
						if ((iIndex > -1) && (iIndex < aPlaylist.Count)) {
							aPlaylist.RemoveAt(iIndex);
							aPlaylist.Insert(iIndex + 1, strTrack);
						}
					}
					UpdatePlaylistContents();
					foreach (string strTrack in aSelectedTracks)
						lstPlaylistContents.SetSelected(lstPlaylistContents.Items.IndexOf(strTrack), true);
				}
			}
		}

		private void btnPlaylistContentsDeleteTracks_Click(object sender, System.EventArgs e) {
			ArrayList aPlaylist = (ArrayList) hPlaylists[txtViewingPlaylist.Text];
			foreach (string strTrack in lstPlaylistContents.SelectedItems)
				aPlaylist.Remove(strTrack);
			UpdatePlaylistContents();
		}

		private void btnPlaylistContentsClear_Click(object sender, System.EventArgs e) {
			ArrayList aPlaylist = (ArrayList) hPlaylists[txtViewingPlaylist.Text];
			aPlaylist.Clear();
			UpdatePlaylistContents();
		}

		private void btnAddPlaylist_Click(object sender, System.EventArgs e) {
			NewPlaylistDialog d = new NewPlaylistDialog();
			d.ShowDialog();
			if ((d.strNewPlaylistName.Length > 0) && (hPlaylists.Contains(d.strNewPlaylistName) == false)) {
				hPlaylists.Add(d.strNewPlaylistName, new ArrayList());
				lstPlaylists.Items.Add(d.strNewPlaylistName);
			}
		}

		private void btnDeletePlaylist_Click(object sender, System.EventArgs e) {
			ArrayList aPlaylists = new ArrayList();
			foreach (string strPlaylist in lstPlaylists.SelectedItems)
				aPlaylists.Add(strPlaylist);
			foreach (string strPlaylist in aPlaylists) {
				lstPlaylists.Items.Remove(strPlaylist);
				hPlaylists.Remove(strPlaylist);
			}
			txtViewingPlaylist.Text = "";
			lstPlaylistContents.Items.Clear();
		}

		private void btnSave_Click(object sender, System.EventArgs e) {
			foreach (string strPlaylistName in hPlaylists.Keys) {
				StreamWriter streamPlaylist = new StreamWriter(strPath + "Playlist - " + strPlaylistName + ".m3u");
				ArrayList aTracks = (ArrayList) hPlaylists[strPlaylistName];
				foreach (String strTrack in aTracks)
					streamPlaylist.WriteLine(hTracks[strTrack]);  // this writes the filename instead of the track name
				streamPlaylist.Close();
			}
			MessageBox.Show("Wrote " + hPlaylists.Count + " playlists.");
		}

		private void PlaylistManager_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			if ((e.KeyCode == Keys.LControlKey) || (e.KeyCode == Keys.RControlKey) || (e.KeyCode == Keys.Control) || (e.KeyCode == Keys.ControlKey))
				bControlDown = true;
		}

		private void PlaylistManager_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
			if ((e.KeyCode == Keys.LControlKey) || (e.KeyCode == Keys.RControlKey) || (e.KeyCode == Keys.Control) || (e.KeyCode == Keys.ControlKey))
				bControlDown = false;
		}

		private void lstTracks_SelectedIndexChanged(object sender, System.EventArgs e) {
			if (bUpdatingTracks == false) {
				if (bControlDown == true) {  // ctrl-left-clicked - associate or disassociate with tracks
					/* This does nothing at present. Must figure out how to get the text of an item that has just been unselected in order to implement this functionality.
					bool bSelected = false;
					if (lstTracks.SelectedItems.Contains(lstTracks.Text))
						bSelected = true;
					*/
				} else {  // left-clicked - show playlists associated with track
					if (lstTracks.SelectedItems.Count == 0)
						lstPlaylists.ClearSelected();
					else {
						bUpdatingPlaylists = true;
						lstPlaylists.BeginUpdate();
						for (int i = 0; i < lstPlaylists.Items.Count; i++)
							lstPlaylists.SetSelected(i, true);
						foreach (string strSelectedTrack in lstTracks.SelectedItems) {
							for (int i = 0; i < lstPlaylists.Items.Count; i++) {
								if (((ArrayList) hPlaylists[lstPlaylists.Items[i]]).Contains(strSelectedTrack) == false)
									lstPlaylists.SetSelected(i, false);
							}
						}
						lstPlaylists.EndUpdate();
						bUpdatingPlaylists = false;
					}
				}
			}
		}

		private void lstPlaylists_SelectedIndexChanged(object sender, System.EventArgs e) {
			if (bUpdatingPlaylists == false) {
				if (lstPlaylists.Text == "") {
					txtViewingPlaylist.Text = "";
					lstPlaylistContents.Items.Clear();
				} else {
					txtViewingPlaylist.Text = lstPlaylists.Text;
					UpdatePlaylistContents();
				}
			}
		}

		private void txtTrackSearch_TextChanged(object sender, System.EventArgs e) {
			if (txtTrackSearch.Text.Length > 0) {
				string strSelected = "";
				string strTrackSearch = txtTrackSearch.Text.ToLower();
				foreach (string strTrack in hTracks.Keys) {
					if ((strTrack.ToLower().StartsWith(strTrackSearch) == true) && ((strSelected == "") || (String.Compare(strTrack, strSelected) < 0)))
						strSelected = strTrack;
				}
				if (strSelected != "")
					lstTracks.TopIndex = lstTracks.Items.IndexOf(strSelected);
			}
		}

		#endregion

		#region Other event handlers

		private void PlaylistManager_Load(object sender, System.EventArgs e) {
			hTracks = new Hashtable();
			hPlaylists = new Hashtable();
		}

		private void PlaylistManager_Resize(object sender, System.EventArgs e) {
			// resize Tracks list and nearby controls
			lstTracks.Left = 8;
			lstTracks.Width = (this.Width - 50) * 224 / 632;
			lstTracks.Top = 32;
			lstTracks.Height = this.Height - 98;
			btnChooseFolder.Left = lstTracks.Left + (lstTracks.Width - btnChooseFolder.Width) / 2;
			lblSearch.Left = lstTracks.Left;
			btnAddTracksToPlaylists.Left = lstTracks.Right - btnAddTracksToPlaylists.Width;
			txtTrackSearch.Left = lblSearch.Right;
			txtTrackSearch.Width = lstTracks.Width - lblSearch.Width - btnAddTracksToPlaylists.Width - 4;

			// resize Playlists list and nearby controls
			lstPlaylists.Left = lstTracks.Right + 8;
			lstPlaylists.Width = (this.Width - 50) * 184 / 632;
			lstPlaylists.Top = 32;
			lstPlaylists.Height = this.Height - 98;
			btnSave.Left = lstPlaylists.Left + (lstPlaylists.Width - btnSave.Width) / 2;
			int iGap = (lstPlaylists.Width - btnAddPlaylist.Width - btnDeletePlaylist.Width) / 3;
			btnAddPlaylist.Left = lstPlaylists.Left + iGap;
			btnDeletePlaylist.Left = lstPlaylists.Right - btnDeletePlaylist.Width - iGap;

			// resize Playlist Contents list and nearby controls
			lstPlaylistContents.Left = lstPlaylists.Right + 8;
			lstPlaylistContents.Width = (this.Width - 50) * 224 / 632;
			lstPlaylistContents.Top = 32;
			lstPlaylistContents.Height = this.Height - 98;
			lblPlaylist.Left = lstPlaylistContents.Left;
			txtViewingPlaylist.Left = lblPlaylist.Right;
			txtViewingPlaylist.Width = lstPlaylistContents.Width - lblPlaylist.Width;
			iGap = (lstPlaylistContents.Width - btnPlaylistContentsMoveUp.Width - btnPlaylistContentsMoveDown.Width - btnPlaylistContentsDeleteTracks.Width - btnPlaylistContentsClear.Width) / 5;
			btnPlaylistContentsMoveUp.Left = lstPlaylistContents.Left + iGap;
			btnPlaylistContentsMoveDown.Left = btnPlaylistContentsMoveUp.Right + iGap;
			btnPlaylistContentsDeleteTracks.Left = btnPlaylistContentsMoveDown.Right + iGap;
			btnPlaylistContentsClear.Left = btnPlaylistContentsDeleteTracks.Right + iGap;
		}

		#endregion

		#region Helper functions

		private void ScanFolder(string strFolder) {
			// This function loads and parses all of the M3Us from the selected directory, and checks the contents of each against the contents of the file folder. If any entries are nonexistent, this function
			// creates a PlaylistWarningsDialog to notify the user.

			strPath = strFolder + @"\";
			ArrayList aWarnings = new ArrayList();
			hTracks = new Hashtable();
			hPlaylists = new Hashtable();
			lstPlaylists.BeginUpdate();
			lstPlaylists.Items.Clear();
			lstTracks.BeginUpdate();
			lstTracks.Items.Clear();
			// This next bit of code is a little bit of tap-dancing. We want to remember both the name of the file ("foo.mp3") and also create a user-friendly name, i.e., with the extension removed ("foo").
			// The trick is that we need to remember what the extension was to write the playlist accordingly. We do this by storing the user-friendly name as the hashtable key, and the actual filename as
			// the associated hashtable value. Also, since we can't tell exactly what constitutes a media track and what doesn't (MID? MDI? WMV? WMA? OGG? etc.),, we will just consider every file in
			// this folder that doesn't end in "m3u" to be a media file. Imperfect, but the best solution without a lot of guesswork and ongoing maintenance.
			string[] astrTracks = System.IO.Directory.GetFiles(strFolder);
			ArrayList aTracks = new ArrayList();
			foreach (string strTrack in astrTracks) {
				if (strTrack.ToLower().EndsWith(".m3u") == false)
					aTracks.Add(strTrack);
			}
			foreach (string strTrackFull in aTracks) {
				string strTrackFilename = strTrackFull.Substring(strFolder.Length + 1, strTrackFull.Length - strFolder.Length - 1).Trim();
				string strTrackName = strTrackFilename;
				if (strTrackName.LastIndexOf(".") != -1)  // trim off the file extension
					strTrackName = strTrackName.Substring(0, strTrackName.LastIndexOf(".")).Trim();
				if (strTrackName.Length > 0) {
					lstTracks.Items.Add(strTrackName);
					hTracks.Add(strTrackName, strTrackFilename);
				}
			}
			// This part of the code parses the playlists.
			string[] astrPlaylists = System.IO.Directory.GetFiles(strFolder, "Playlist - *.m3u");
			foreach (string strPlaylistFull in astrPlaylists) {
				string strPlaylist = strPlaylistFull.Substring(strFolder.Length + 12, strPlaylistFull.Length - 16 - strFolder.Length);
				lstPlaylists.Items.Add(strPlaylist);
				ArrayList aPlaylistContents = new ArrayList();
				StreamReader streamPlaylist = new StreamReader(strPlaylistFull);
				string strPlaylistTrackFull = streamPlaylist.ReadLine();
				while (strPlaylistTrackFull != null) {
					if (strPlaylistTrackFull.StartsWith(strFolder) == true)
						strPlaylistTrackFull = strPlaylistTrackFull.Substring(strFolder.Length);
					string strPlaylistTrack = strPlaylistTrackFull.Substring(0, strPlaylistTrackFull.Length - 4);
					if (hTracks.ContainsKey(strPlaylistTrack))
						aPlaylistContents.Add(strPlaylistTrack);
					else
						aWarnings.Add("Playlist " + strPlaylist + " references nonexistent track " + strPlaylistTrack + ".");
					strPlaylistTrackFull = streamPlaylist.ReadLine();  // read next line
				}
				streamPlaylist.Close();
				hPlaylists.Add(strPlaylist, aPlaylistContents);
			}
			lstPlaylists.EndUpdate();
			lstTracks.EndUpdate();
			// Check and see if we had any warnings. If so, display a warnings dialog.
			if (aWarnings.Count > 0) {
				PlaylistWarningsDialog d = new PlaylistWarningsDialog(aWarnings);
				d.Show();
			}
		}

		private void UpdatePlaylistContents() {
			lstPlaylistContents.Items.Clear();
			if (txtViewingPlaylist.Text.Length > 0) {
				ArrayList aPlaylist = (ArrayList) hPlaylists[lstPlaylists.Text];
				if (aPlaylist != null) {
					foreach (string strTrack in aPlaylist)
						lstPlaylistContents.Items.Add(strTrack);
				}
			}
		}

		#endregion

	}
}
