// Playlist Manager v1.0
// Written by David J. Stein, Esq. See "License.html" for information on terms and conditions of use.
//
// This module contains the code for a list of warnings encountered while parsing the M3U lists.

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace PlaylistManagerNS {

	public class PlaylistWarningsDialog : System.Windows.Forms.Form	{

		#region Variables and initialization code

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.ListBox lstWarnings;
		private System.ComponentModel.Container components = null;
		private ArrayList aWarnings;

		public PlaylistWarningsDialog(ArrayList aWarnings)	{
			InitializeComponent();
			this.aWarnings = aWarnings;
		}

		#region Uninteresting Windows Form Designer generated code
		protected override void Dispose(bool disposing)		{
			if (disposing) {
				if (components != null) {
				components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

	private void InitializeComponent()	{
		System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(PlaylistWarningsDialog));
		this.label1 = new System.Windows.Forms.Label();
		this.btnOK = new System.Windows.Forms.Button();
		this.lstWarnings = new System.Windows.Forms.ListBox();
		this.SuspendLayout();
		// 
		// label1
		// 
		this.label1.Anchor = System.Windows.Forms.AnchorStyles.Top;
		this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
		this.label1.Location = new System.Drawing.Point(8, 8);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(352, 48);
		this.label1.TabIndex = 0;
		this.label1.Text = "Note: The playlists in this folder include references to some MP3s that don\'t exi" +
			"st in this folder. Here is a list of the nonexistent MP3s:";
		this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
		// 
		// btnOK
		// 
		this.btnOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
		this.btnOK.Location = new System.Drawing.Point(147, 264);
		this.btnOK.Name = "btnOK";
		this.btnOK.TabIndex = 1;
		this.btnOK.Text = "OK";
		this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
		// 
		// lstWarnings
		// 
		this.lstWarnings.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.lstWarnings.Location = new System.Drawing.Point(8, 64);
		this.lstWarnings.Name = "lstWarnings";
		this.lstWarnings.Size = new System.Drawing.Size(352, 186);
		this.lstWarnings.TabIndex = 2;
		// 
		// PlaylistWarningsDialog
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(368, 289);
		this.Controls.Add(this.lstWarnings);
		this.Controls.Add(this.btnOK);
		this.Controls.Add(this.label1);
		this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
		this.Name = "PlaylistWarningsDialog";
		this.Text = "Playlist Warnings";
		this.Load += new System.EventHandler(this.PlaylistWarningsDialog_Load);
		this.ResumeLayout(false);

	}
		#endregion

		#endregion

		#region User control event handlers

		private void btnOK_Click(object sender, System.EventArgs e) {
			Close();
		}

		private void PlaylistWarningsDialog_Load(object sender, System.EventArgs e) {
			foreach (string strWarning in aWarnings)
				lstWarnings.Items.Add(strWarning);
		}

		#endregion

	}
}
